org.codehaus.groovy.ast

## Class GenericsType

- java.lang.Object
- - org.codehaus.groovy.ast.ASTNode
  - - org.codehaus.groovy.ast.GenericsType

-     public class GenericsType
      extends ASTNode

  This class is used to describe generic type signatures for ClassNodes.
  See Also:
    `ClassNode`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `GenericsType.GenericsTypeName` Represents GenericsType name TODO In order to distinguish GenericsType with same name(See GROOVY-8409), we should add a property to keep the declaring class.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static GenericsType[]` | `EMPTY_ARRAY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GenericsType(ClassNode basicType)`
    `GenericsType(ClassNode type, ClassNode[] upperBounds, ClassNode lowerBound)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ClassNode` | `getLowerBound()`
    `java.lang.String` | `getName()`
    `ClassNode` | `getType()`
    `ClassNode[]` | `getUpperBounds()`
    `boolean` | `isCompatibleWith(ClassNode classNode)` Tells if the provided class node is compatible with this generic type definition
    `boolean` | `isPlaceholder()`
    `boolean` | `isResolved()`
    `boolean` | `isWildcard()`
    `void` | `setName(java.lang.String name)`
    `void` | `setPlaceholder(boolean placeholder)`
    `void` | `setResolved(boolean res)`
    `void` | `setType(ClassNode type)`
    `void` | `setWildcard(boolean wildcard)`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class org.codehaus.groovy.ast.ASTNode

      `copyNodeMetaData, equals, getColumnNumber, getLastColumnNumber, getLastLineNumber, getLineNumber, getMetaDataMap, getNodeMetaData, getNodeMetaData, getText, hashCode, putNodeMetaData, removeNodeMetaData, setColumnNumber, setLastColumnNumber, setLastLineNumber, setLineNumber, setNodeMetaData, setSourcePosition, visit`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### EMPTY_ARRAY

          public static final GenericsType[] EMPTY_ARRAY

  - ### Constructor Detail

    - #### GenericsType

          public GenericsType(ClassNode type,
                              ClassNode[] upperBounds,
                              ClassNode lowerBound)

    - #### GenericsType

          public GenericsType(ClassNode basicType)

  - ### Method Detail

    - #### getType

          public ClassNode getType()

    - #### setType

          public void setType(ClassNode type)

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### getUpperBounds

          public ClassNode[] getUpperBounds()

    - #### getName

          public java.lang.String getName()

    - #### isPlaceholder

          public boolean isPlaceholder()

    - #### setPlaceholder

          public void setPlaceholder(boolean placeholder)

    - #### isResolved

          public boolean isResolved()

    - #### setResolved

          public void setResolved(boolean res)

    - #### setName

          public void setName(java.lang.String name)

    - #### isWildcard

          public boolean isWildcard()

    - #### setWildcard

          public void setWildcard(boolean wildcard)

    - #### getLowerBound

          public ClassNode getLowerBound()

    - #### isCompatibleWith

          public boolean isCompatibleWith(ClassNode classNode)

      Tells if the provided class node is compatible with this generic type definition
      Parameters:
        `classNode` - the class node to be checked
      Returns:
        true if the class node is compatible with this generics type definition